function delta = BEG_b_error(a,E,G)
% Computes backward error on polynomial coefficients for QZ
% according to Boito, Eidelman, Gemignani (2013).
%
% Input:
% - column vector a of polynomial coefficients
%   (starting from constant term).
%
% Output:
% - column vector delta of perturbations.

n=length(a)-1;
%E=eps*triu(ones(n),-2);
%G=eps*triu(ones(n),-1);
%E=eps*rand(n); 
%G=eps*rand(n);

% form companion matrix (polynomial in last column)
C=[[zeros(1,n-1);eye(n-1)],-a(1:n)];
d=a(n+1);

delta_a=EM_b_error(E-G*C,[a(1:n);1]); 
delta_a_tilde=EM_b_error(E(1:n-1,1:n-1)-G(1:n-1,1:n-1)*C(1:n-1,1:n-1),[zeros(n-1,1);1]);
t_G=trace(G);
t_G_tilde=trace(G(1:n-1,1:n-1));

% old computation
%delta=zeros(n+1,1);
%delta(1)=delta_a(1)+a(1)*t_G;
%delta(n+1)=t_G-(d-1)*(t_G);
%delta(2:n)=delta_a(2:n)+a(2:n)*t_G-(d-1)*(delta_a_tilde(1:n-1)+a(2:n)*t_G);

% other computation 
 syms x
 q=poly2sym(flipud([a(1:n);1]));
 ourpoly=poly2sym(flipud(delta_a))+t_G*q+x*(d-1)*(poly2sym(flipud(delta_a_tilde))+t_G_tilde*x^(n-1));
 delta=sym2poly(ourpoly);
 delta=flipud(delta);
end

