% Comparison QZ vs QR on a "jumping polynomial".


d=60;
n=20;
p=zeros(1,n+1);
for k=1:n+1
%p(k)=10^(6*(-1)^(k));
p(k)=10^((6)*(-1)^(k)-3);
end
%p(1)=10^(-11)
p=fliplr(p);
% compute exact_roots using symbolic package
ps=num2str(p(n+1));
for j=1:n
    ps=strcat(ps,'+',num2str(p(n-j+1)),'*x^',num2str(j));
end
symb_roots=solve(ps);
exact_roots=double(symb_roots);

roots_matrix_bal_nonorm=roots(p);
roots_matrix_nobal_nonorm=eig(compan(p),'nobalance');
pp=p;
P=p/norm(p);   % normalize polynomial
Aa=[-(P(2:n+1));eye(n-1),zeros(n-1,1)];
 Bb=eye(n);
 Bb(1,1)=P(1);
 fast_companion_QZ;
 myroots=adiag./bdiag;
 roots_matrix_bal=roots(P);
 roots_matrix_nobal=eig(compan(P),'nobalance');
 roots_pencil=eig(Aa,Bb);
 % compute and print forward errors
 fprintf('Forward errors for fast QZ : \n')
 AbsDistance(myroots,exact_roots)
 RelDistance(myroots,exact_roots)
 fprintf('Forward errors for classical QZ : \n')
 AbsDistance(roots_pencil,exact_roots)
 RelDistance(roots_pencil,exact_roots)
 fprintf('Forward errors for balanced QR : \n')
 AbsDistance(roots_matrix_bal,exact_roots)
 RelDistance(roots_matrix_bal,exact_roots)
 fprintf('Forward errors for balanced QR without normalization: \n')
 AbsDistance(roots_matrix_bal_nonorm,exact_roots)
 RelDistance(roots_matrix_bal_nonorm,exact_roots)
 fprintf('Forward errors for unbalanced QR : \n')
 AbsDistance(roots_matrix_nobal,exact_roots)
 RelDistance(roots_matrix_nobal,exact_roots)
 fprintf('Forward errors for unbalanced QR without normalization: \n')
 AbsDistance(roots_matrix_nobal_nonorm,exact_roots)
 RelDistance(roots_matrix_nobal_nonorm,exact_roots)
 % compute and print backward errors (polynomials are monic)
 mycoeff=compute_coeff_vpa(myroots,d);
 coeff_matrix_bal=compute_coeff_vpa(roots_matrix_bal,d);
 coeff_matrix_nobal=compute_coeff_vpa(roots_matrix_nobal,d);
 coeff_matrix_bal_nonorm=compute_coeff_vpa(roots_matrix_bal_nonorm,d);
 coeff_matrix_nobal_nonorm=compute_coeff_vpa(roots_matrix_nobal_nonorm,d);
 coeff_pencil=compute_coeff_vpa(roots_pencil,d);
 % normalize polynomials w.r.t. 2-norm
 mycoeff2=mycoeff/norm(mycoeff);
 coeff_matrix_bal2=coeff_matrix_bal/norm(coeff_matrix_bal);
 coeff_matrix_nobal2=coeff_matrix_nobal/norm(coeff_matrix_nobal);
 coeff_matrix_bal2_nonorm=coeff_matrix_bal_nonorm/norm(coeff_matrix_bal_nonorm);
 coeff_matrix_nobal2_nonorm=coeff_matrix_nobal_nonorm/norm(coeff_matrix_nobal_nonorm);
 coeff_pencil2=coeff_pencil/norm(coeff_pencil);
 fprintf('Backward errors for fast QZ : \n')
 norm(double(mycoeff2)-P,'inf')
 norm((double(mycoeff2)-P)./P,'inf')
 fprintf('Backward errors for classical QZ : \n')
 norm(double(coeff_pencil2)-P,'inf')
 norm((double(coeff_pencil2)-P)./P,'inf')
 fprintf('Backward errors for balanced QR with normalization: \n')
 norm(double(coeff_matrix_bal2)-P,'inf')
 norm((double(coeff_matrix_bal2)-P)./P,'inf')
 fprintf('Backward errors for balanced QR without normalization: \n')
 norm(double(coeff_matrix_bal2_nonorm)-P,'inf')
 norm((double(coeff_matrix_bal2_nonorm)-P)./P,'inf')
 fprintf('Backward errors for unbalanced QR : \n')
 norm(double(coeff_matrix_nobal2)-P,'inf')
 norm((double(coeff_matrix_nobal2)-P)./P,'inf')
 fprintf('Backward errors for unbalanced QR without normalization: \n')
 norm(double(coeff_matrix_nobal2_nonorm)-P,'inf')
 norm((double(coeff_matrix_nobal2_nonorm)-P)./P,'inf')