function B=recover_B(db,gu,hu,bu,p,q);
% recovers matrix B from its quasiseparable generators

N=length(p);  % matrix size
B=zeros(N);

% fill diagonal
for k=1:N
    B(k,k)=db(k);
end

% fill upper triangular part:
for j=1:N-2  % fill each row
    x=gu(j);
    for k=j+1:N-1
        B(j,k)=x*hu(k)-p(j)*q(k)';
        x=x*bu(k);
    end
    B(j,N)=x*hu(N)-p(j)*q(N)';
end
B(N-1,N)=gu(N-1)*hu(N)-p(N-1)*q(N)';